<?php
if($member || $admin || $banManager || $fullPower) {

require_once(ROOTDIR."/include/database/class.ServerQueries.php");
require_once(ROOTDIR."/include/database/class.ReasonQueries.php");
require_once(ROOTDIR."/include/database/class.BanQueries.php");

// Initialize Objects
$serverQueries = new ServerQueries();
$reasonQueries = new ReasonQueries();
$banQueries = new BanQueries();

// Ban ID
$banId = $_GET['banId'];

// Get the list of servers
$serverList = $serverQueries->getServers();

// List of Reasons
$banReasons = $reasonQueries->getReasonList();

// Banned user information
$bannedUser = $banQueries->getBannedUser($banId);

?>
<script type="text/javascript">
<!--
function confirmIpBan() {
	if (confirm('Do you really want to ban this IP?')){
    document.getElementById('banIpForm').submit()
	}
}
//-->
</script>
<div class="tborder">
<div id="tableHead">
  <div><b>Update Ban Information</b</div>
</div>
<form action="index.php?page=processWebBanUpdate" method="POST">
<input type="hidden" name="banId" value="<?=$banId?>">
<table class="bordercolor" width="100%" cellspacing="1" cellpadding="5" border="0" style="margin-top: 1px;">
<tr>
  <td class="rowColor1" width="1%" nowrap>Steam ID:</td>
  <td class="rowColor1"><?=$bannedUser->getSteamId()?></td>
</tr>
<tr>
  <td class="rowColor2" width="1%" nowrap>IP Address:</td>
  <td class="rowColor2"><?=$bannedUser->getIp()?>
  <?php
    if($banQueries->isIpBanned($bannedUser->getIp())) {
      ?><span class="error">&nbsp; &lt;&lt; IP Banned &gt;&gt; </span><?php
    } else {
      // Only admins, ban mangers, and full power admins can IP ban
      // Members are not allowed to IP ban
      if($admin || $banManager || $fullPower) {
        ?><input type="button" value="Ban IP" onclick="confirmIpBan()"><?php
      }
    }
  ?>
  </td>
</tr>
<tr>
  <td class="rowColor1" width="1%" nowrap>Person Banned:</td>
  <td class="rowColor1"><input type="text" name="bannedUser" size="40" maxlength="128" value="<?=$bannedUser->getName()?>"/></td>
</tr>
<tr>
  <td class="rowColor2" width="1%" nowrap>Banned By:</td>
  <td class="rowColor2"><?=$bannedUser->getBanner()?></td>
</tr>
<tr>
  <td class="rowColor1" width="1%" nowrap>Length of Ban:</td>
  <td class="rowColor1">
    <select name="length">
      <option value="00" <?php if($bannedUser->getLength() == "0") echo "selected"; ?>>Perma Ban</option>
      <option value="01" <?php if($bannedUser->getLength() == "1") echo "selected"; ?>>1 Hour</option>
      <option value="24" <?php if($bannedUser->getLength() == "24") echo "selected"; ?>>1 Day</option>
      <option value="168" <?php if($bannedUser->getLength() == "168") echo "selected"; ?>>1 Week</option>
      <option value="336" <?php if($bannedUser->getLength() == "336") echo "selected"; ?>>2 Weeks</option>
      <option value="730" <?php if($bannedUser->getLength() == "730") echo "selected"; ?>>1 Month</option>
    </select>
  </td class="rowColor1">
</tr>
<tr>
  <td class="rowColor2" width="1%" nowrap>Server:</td>
  <td class="rowColor2">
    <select name="serverId">
    <?php
    if(count($serverList > 0)) {
      for($i=0; $i<count($serverList);$i++) {
        $server = $serverList[$i];
        if($server->getId() == $bannedUser->getServerId()) {
          ?><option value="<?=$server->getId()?>" selected><?=$server->getName()?></option><?php
        } else {
          ?><option value="<?=$server->getId()?>"><?=$server->getName()?></option><?php
        }
      }
    } else {
    ?><option value="-1">No Servers</option><?php
    }
    ?>
    </select>
  </td>
</tr>
<tr>
  <td class="rowColor1" width="1%" nowrap>Reason:</td>
  <td class="rowColor1">
    <select name="reason">
    <?php
    // Make sure we have a list of ban reasons to display
    if(count($banReasons > 0)) {
      // Ignore first reason as it is a generic reason for importing bans from a ban list
      for($i=0; $i<count($banReasons);$i++) {
        $reason = $banReasons[$i]; 
        if($reason->getId() == $bannedUser->getReasonId()) {
          ?><option value="<?=$reason->getId()?>" selected><?=$reason->getReason()?></option><?php
        } else {
          ?><option value="<?=$reason->getId()?>"><?=$reason->getReason()?></option><?php
        }
      }
    } else {
    ?><option value="-1">Breaking Server Rules</option><?php
    }
    ?>
    </select>
  </td>
</tr>
<tr>
  <td class="rowColor2" width="1%" valign="top" nowrap>Comments:</td>
  <td class="rowColor2"><textarea id="comments" name="comments" cols="30" rows="5"><?=$bannedUser->getComments()?></textarea></td>
</tr>
<tr>
  <td class="rowColor1" width="1%" nowrap>Last Modified By:</td>
  <?php
  if($bannedUser->getModifiedBy() == "") { 
  ?>
    <td class="rowColor1"><?=$bannedUser->getBanner()?></td>
  <?php
  } else {
  ?>
    <td class="rowColor1"><?=$bannedUser->getModifiedBy()?></td>
  <?php
  }
  ?>
</tr>
<tr>
  <td colspan="2" class="rowColor2"><input type="submit" name="updateBan" value="Update Ban"></td>
</tr>
</table>
</form>
<form name="bandIpForm" id="banIpForm" action="index.php?page=processWebBanUpdate" method="POST">
  <input type="hidden" name="banIp" id="banIp" value="1"/>
  <input type="hidden" name="banId" value="<?=$banId?>">
  <input type="hidden" name="ip" id="ip" value="<?=$bannedUser->getIp()?>"/>
</form>
</div>
<?php
} else {
?>
<div class="tborder">
  <div id="tableHead">
    <div><b>Access Denied/b</div>
  </div>
</div>
<?php
}
?>
